Check for existence of debootstrap binary after command line processing
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8
9 # error_handler {{{
10 [ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
11 [ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
12
13 error_handler() {
14    last_exit_code="$?"
15    last_bash_command="$BASH_COMMAND"
16    if [ "$REPORT_TRAP_ERR" = "yes" ]; then
17       echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
18 last bash command: $last_bash_command"
19    fi
20    if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
21       return
22    fi
23    ## Check if "bailout" function is available.
24    ## This is not the case in chroot-script.
25    if command -v bailout >/dev/null 2>&1; then
26       bailout 1
27    else
28       echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
29       exit 1
30    fi
31 }
32
33 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
34    set -E
35    set -o pipefail
36    trap "error_handler" ERR
37    export -f "error_handler"
38 fi
39 # }}}
40
41 # variables {{{
42 PN="$(basename "$0")"
43 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
44   VERSION="$(git describe | sed 's|^v||')"
45 else
46   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
47 fi
48 VERSION="${VERSION:-unknown}"
49 MNTPOINT="/mnt/debootstrap.$$"
50
51 # defaults
52 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
53 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
54 [ -n "$DEBCONF" ] || DEBCONF='yes'
55 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
56 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
57 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
58 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
59 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
60 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
61 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
62 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
63 [ -n "$FORCE" ] || FORCE=''
64 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
65 [ -n "$INITRD" ] || INITRD='yes'
66 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
67 [ -n "$LOCALES" ] || LOCALES='yes'
68 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
69 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
70 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
71 [ -n "$PACKAGES" ] || PACKAGES='yes'
72 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
73 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
74 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
75 [ -n "$RELEASE" ] || RELEASE='buster'
76 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
77 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
78 [ -n "$SECURE" ] || SECURE='yes'
79 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
80 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
81 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
82 [ -n "$VMSIZE" ] || VMSIZE="2G"
83 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
84
85 # inside the chroot system locales might not be available, so use minimum:
86 export LANG=C
87 export LC_ALL=C
88 export LANGUAGE=C
89
90 # make sure interactive mode is only executed when
91 # using an empty configuration file or option --interactive
92 INTERACTIVE=''
93 # }}}
94
95 # help text {{{
96 usage() {
97   echo "$PN - wrapper around debootstrap for installing Debian
98
99 Usage: $PN [options]
100
101 Bootstrap options:
102
103   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
104   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
105                          instead of fetching packages from a mirror.
106   -r, --release <name>   Release of new Debian system (default: buster).
107   -t, --target <target>  Target partition (/dev/...) or directory where the
108                          system should be installed to.
109   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
110                          has no effect if -t is given and represents a directory.
111       --debopt <params>  Extra parameters passed to the debootstrap command.
112       --interactive      Use interactive mode (frontend).
113       --nodebootstrap    Skip debootstrap, only do configuration to the target.
114       --grub <device>    Target for grub installation. Usage example: /dev/sda
115       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
116       --arch <arch>      Set target architecture, use for installing i386 on amd64.
117       --filesystem <fs>  Filesystem that should be used when target is a partition
118                          or Virtual Machine (see --vmfile).
119       --force            Do not prompt for user acknowledgement.
120
121 Options for Virtual Machine deployment:
122
123       --vm               Set up a Virtual Machine on an existing block device
124                          instead of plainly installing to a partition or
125                          directory. Needs to be combined with --target.
126                          Example: --vm --target /dev/mapper/your-vm-disk
127       --vmfile           Like --vm, but install into a regular file (created by
128                          'qemu-img create -f raw ...') instead.
129                          Example: --vmfile --target /mnt/sda1/qemu.img
130       --vmsize <size>    Use specified size for size of VM file (default: 2G).
131                          Syntax as supported by qemu-img, like: --vmsize 3G
132
133 Configuration options:
134
135   -c, --config <file>      Use specified configuration file, defaults to
136                              /etc/debootstrap/config
137   -d, --confdir <path>     Place of config files for debootstrap, defaults
138                              to /etc/debootstrap
139       --packages <file>    Install packages defined in specified list file
140                              instead of using /etc/debootstrap/packages.
141       --nopackages         Skip installation of packages defined in
142                              /etc/debootstrap/packages
143       --nokernel           Skip installation of default kernel images.
144       --nointerfaces       Do not copy /etc/network/interfaces from host system
145                            to target system.
146                            (This option is automatically enabled when using --vmfile.)
147       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
148                            DHCP for eth0) instead of taking over config from host system.
149       --debconf <file>     Pre-seed packages using specified pre-seed db file.
150       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
151       --backportrepos      Enable Debian's backports repository (backports.debian.org).
152       --keep_src_list      Do not overwrite user provided apt sources.list.
153       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
154       --non-free           Enable non-free in COMPONENTS (defaults to 'main' only).
155       --hostname <name>    Hostname of Debian system.
156       --nopassword         Do not prompt for the root password.
157       --password <pwd>     Use specified password as password for user root.
158       --sshcopyid          Use locally available public keys to authorise root login on the target system.
159       --bootappend <line>  Add specified appendline to kernel whilst booting.
160       --chroot-scripts <d> Execute chroot scripts from specified directory.
161       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
162       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
163       --remove-configs     Delete grml-debootstrap configuration files from installed system.
164
165 Other options:
166
167   -v, --verbose            Increase verbosity.
168       --debug              Execute in very verbose way.
169   -h, --help               Print this usage information and exit.
170   -V, --version            Show summary of options and exit.
171
172 Usage examples can be found in the grml-debootstrap manpage.
173 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
174 "
175 }
176
177 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
178    usage
179    echo 'Please notice that this script requires root permissions!'
180    exit 0
181 fi
182 # }}}
183
184 # early helper functions {{{
185 GOOD='\e[32;01m'
186 BAD='\e[31;01m'
187 WARN='\e[33;01m'
188 NORMAL='\e[0m'
189
190 einfo() {
191   einfon "$1\\n"
192   return 0
193 }
194
195 einfon() {
196   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
197   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
198   LAST_E_CMD=einfon
199   return 0
200 }
201
202 ewarn() {
203   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
204   return 0
205 }
206
207 eerror() {
208   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
209   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
210   LAST_E_CMD=eerror
211   return 0
212 }
213
214 eend() {
215   local retval="${1:-0}"
216   shift
217   if [ "$retval" -gt 0 ]; then
218     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
219   fi
220   return "$retval"
221 }
222
223 check4root(){
224   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
225     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
226   fi
227 }
228
229 check4progs(){
230   local RC=''
231   for arg in "$@" ; do
232     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
233   done
234   if [ -n "$RC" ] ; then
235      echo "$RC not installed"
236      return 1
237   fi
238 }
239 # }}}
240
241 # helper functions {{{
242 cleanup() {
243   if [ -n "$CHROOT_VARIABLES" ] ; then
244     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
245   fi
246
247   if [ -n "$STAGES" ] ; then
248     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
249   fi
250
251   # Remove temporary mountpoint again
252   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
253     rmdir "$MNTPOINT" 2>/dev/null
254   fi
255
256   # make sure $TARGET is not mounted when exiting grml-debootstrap
257   if [ -n "$MNTPOINT" ] ; then
258     if grep -q "$MNTPOINT" /proc/mounts ; then
259       # make sure nothing is left inside chroot so we can unmount it
260       for service in ssh mdadm ; do
261         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
262           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
263         fi
264       done
265
266       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
267
268       # ugly, but make sure we really don't leave anything (/proc /proc and
269       # /dev /dev are intended, trying to work around timing issues, see #657023)
270       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
271         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
272         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
273       done
274
275       if [ -n "$ISODIR" ] ; then
276         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
277       fi
278
279       if [ -n "$DIRECTORY" ] ; then
280         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
281       else
282         einfo "Unmounting $MNTPOINT"
283         umount "$MNTPOINT"
284         eend $?
285       fi
286
287       if [ -n "$STAGES" ] ; then
288         echo -n "Removing stages directory ${STAGES}: "
289         rm -rf "$STAGES" && echo 'done'
290       fi
291
292       # remove directory only if we used the default with process id inside the name
293       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
294         einfo "Removing directory ${MNTPOINT}"
295         rmdir "$MNTPOINT"
296         eend $?
297       fi
298     fi
299   fi
300
301   if [ -n "${ORIG_TARGET}" ] ; then
302     einfo "Removing loopback mount of file ${ORIG_TARGET}."
303     kpartx -d "${ORIG_TARGET}"
304     # Workaround for a bug in kpartx which doesn't clean up properly,
305     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
306     if dmsetup ls | grep -q "^${LOOP_PART} "; then
307       kpartx -d "/dev/${LOOP_DISK}" >/dev/null
308     fi
309     eend $?
310   fi
311 }
312
313 # we want to exit smoothly and clean:
314 bailout(){
315
316   cleanup
317
318   [ -n "$1" ] && EXIT="$1" || EXIT="1"
319   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
320
321   exit "$EXIT"
322 }
323 trap bailout HUP INT QUIT TERM
324
325 # we want to execute all the functions only once, simple check for it:
326 stage() {
327   if [ -n "$2" ] ; then
328      echo "$2" > "${STAGES}/${1}"
329      return 0
330   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
331      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
332      ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
333      return 1
334   fi
335 }
336 # }}}
337
338 # source main configuration file {{{
339 if [ -r /etc/debootstrap/config ] ; then
340   # shellcheck disable=SC1091
341   . /etc/debootstrap/config
342 fi
343 # }}}
344
345 # cmdline handling {{{
346 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid
347
348 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
349   $CMDLINE_OPTS -- "$@")
350
351 if [ $? != 0 ]; then
352   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
353 fi
354 eval set -- "$_opt_temp"
355
356 while :; do
357   case "$1" in
358
359   # == Bootstrap options
360   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
361     shift; _opt_mirror="$1"
362     ;;
363   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
364     shift; _opt_iso="$1"
365     ;;
366   --release|-r)        # Release of new Debian system
367     shift; _opt_release="$1"
368     ;;
369   --target|-t)         # Target partition (/dev/...) or directory
370     shift; _opt_target="$1"
371     ;;
372   --vm)                # Virtual machine image (no file)
373     _opt_vm="T"
374     ;;
375   --vmfile)            # Virtual machine file
376     _opt_vmfile="T"
377     ;;
378   --vmsize)            # size of Virtual machine file
379     shift; _opt_vmsize="$1"
380     ;;
381   --mntpoint|-p)       # Mountpoint used for mounting the target system
382     shift; _opt_mntpoint="$1"
383     ;;
384   --debopt)            # Extra parameters passed to the debootstrap command
385     shift; _opt_debopt="$1"
386     ;;
387   --filesystem)        # Filesystem that should be used
388     shift; _opt_filesystem="$1"
389     ;;
390   --interactive)       # Use interactive mode (frontend)
391     _opt_interactive=T
392     ;;
393   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
394     _opt_nodebootstrap=T
395     ;;
396   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
397     _opt_nopackages=T
398     ;;
399   --arch)              # Target architecutre
400     shift; _opt_arch="$1"
401     ;;
402   # just for backwards compatibility
403   --insecure)
404     _opt_insecure=T
405     ;;
406   #
407
408   # == Configuration options
409   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
410     shift; _opt_config="$1"
411     ;;
412   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
413     shift; _opt_confdir="$1"
414     ;;
415   --packages)          # Install packages defined in specified file
416     shift; _opt_packages="$1"
417     _opt_packages_set=T
418     ;;
419   --debconf)           # Pre-seed packages using specified file
420     shift; _opt_debconf="$1"
421     _opt_debconf_set=T
422     ;;
423   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
424     shift; _opt_pre_scripts="$1"
425     _opt_pre_scripts_set=T
426     ;;
427   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
428     shift; _opt_scripts="$1"
429     _opt_scripts_set=T
430     ;;
431   --post-scripts)       # Execute scripts from specified directory
432     shift; _opt_post_scripts="$1"
433     _opt_post_scripts_set=T
434     ;;
435   --chroot-scripts)   # Execute chroot scripts from specified directory
436     shift; _opt_chroot_scripts="$1"
437     _opt_chroot_scripts_set=T
438     ;;
439   --keep_src_list)     # Do not overwrite user provided apt sources.list
440     _opt_keep_src_list=T
441     ;;
442   --hostname)          # Hostname of Debian system
443     shift; _opt_hostname="$1"
444     ;;
445   --password)          # Use specified password as password for user root
446     shift; _opt_password="$1"
447     ;;
448   --defaultinterfaces) # Install default /etc/network/interfaces
449     _opt_defaultinterfaces=T
450     ;;
451   --nointerfaces)      # Skip installation of /etc/network/interfaces
452     _opt_nointerfaces=T
453     ;;
454   --nokernel)          # Skip installation of default kernel images
455     _opt_nokernel=T
456     ;;
457   --nopassword)        # Skip password dialog
458     _opt_nopassword=T
459     ;;
460   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
461     _opt_sshcopyid=T
462     ;;
463   --grmlrepos)         # Enable Grml repository
464     _opt_grmlrepos=T
465     ;;
466   --backportrepos)     # Enable Debian backports repository
467     _opt_backportrepos=T
468     ;;
469   --bootappend)        # Add specified appendline to kernel whilst booting
470     shift; _opt_bootappend="$1"
471     ;;
472   --grub)              # Target for grub installation. Use grub syntax for specifying
473     shift; _opt_grub="$1"
474     ;;
475   --efi)               # Target for EFI boot installation
476     shift; _opt_efi="$1"
477     ;;
478   --contrib)           # Add 'contrib' to list of components
479     _opt_contrib=T
480     ;;
481   --non-free)          # Add 'non-free' to list of components
482     _opt_non_free=T
483     ;;
484   --remove-configs)    # Drop config files from installed system
485     _opt_remove_configs=T
486     ;;
487
488   # == Other options
489   --verbose|-v)        # Increase verbosity
490     if [ "$_opt_verbose" ]; then
491       _opt_verbose=$( _opt_verbose + 1 )
492     else
493       _opt_verbose=1
494     fi
495     ;;
496   --debug)             # Execute in debug mode
497     _opt_debug=T
498     ;;
499   --help|-h)           # Print usage information and exit
500     _opt_help=T
501     ;;
502   --version|-V)        # Show version information and exit
503     _opt_version=T
504     ;;
505   --force)             # Do not prompt for user input
506     _opt_force=T
507     ;;
508   --)
509     shift; break
510     ;;
511   *)
512     eerror "Internal getopt error!"; eend 1 ; exit 1
513     ;;
514   esac
515   shift
516 done
517
518 # == business-logic of command line parameter-processing
519
520 # source configuration file in <confdir> if supplied. {{{
521 [ "$_opt_confdir" ] && {
522   CONFFILES=$_opt_confdir
523   einfo "Using config files under $CONFFILES/."
524   if ! [ -r "$CONFFILES/config" ] ; then
525     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
526   fi
527   # shellcheck disable=SC1091 source=config
528   if ! . "$CONFFILES/config" ; then
529     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
530   fi
531   # restore the command line parameter value
532   CONFFILES=$_opt_confdir
533 }
534 # }}}
535
536 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
537 [ "$_opt_iso" ]                 && ISO=$_opt_iso
538 [ "$_opt_release" ]             && RELEASE=$_opt_release
539 [ "$_opt_target" ]              && TARGET=$_opt_target
540 [ "$_opt_vm" ]                  && VIRTUAL=1
541 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
542 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
543 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
544 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
545 [ "$_opt_interactive" ]         && INTERACTIVE=1
546 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
547 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
548 [ "$_opt_packages_set" ]        && PACKAGES='yes'
549 [ "$_opt_nopackages" ]          && PACKAGES=''
550 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
551 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
552 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
553 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
554 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
555 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
556 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
557 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
558 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
559 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
560 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
561 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
562 [ "$_opt_nokernel" ]            && NOKERNEL="true"
563 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
564 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
565 [ "$_opt_grub" ]                && GRUB=$_opt_grub
566 [ "$_opt_efi" ]                 && EFI=$_opt_efi
567 [ "$_opt_arch" ]                && ARCH=$_opt_arch
568 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
569 [ "$_opt_force" ]               && FORCE=$_opt_force
570 [ "$_opt_verbose" ]             && VERBOSE="-v"
571 [ "$_opt_debug" ]               && DEBUG="true"
572 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
573
574 # make sure main is always included
575 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
576 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
577 [ "$_opt_non_free" ]            && COMPONENTS="$COMPONENTS non-free"
578
579 # command line option checks
580 if [ "$_opt_scripts_set" ] ; then
581   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
582   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
583 fi
584
585 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
586   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
587   eerror "The --grub option is unneeded as GRUB will be installed automatically."
588   eend 1
589   bailout 1
590 fi
591
592 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
593   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
594   eerror "Either drop the --iso ... option or use plain debootstrap instead."
595   eend 1
596   bailout 1
597 fi
598
599 if [ "$DEBUG" = "true" ] ; then
600   set -x
601 fi
602
603 [ "$_opt_help" ] && {
604   usage ; eend 0
605   eend 0
606   exit 0
607 }
608
609 [ "$_opt_version" ] && {
610   einfo "$PN - version $VERSION"
611   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
612   eend 0
613   exit 0
614 }
615 # }}}
616
617 # check for root permissions {{{
618 if ! check4root ; then
619    echo "For usage instructions please execute '$PN --help'."
620    bailout 1
621 fi
622 # }}}
623
624 # make sure we have what we need {{{
625 check4progs "${DEBOOTSTRAP}" || bailout 1
626
627 if [ -n "$VIRTUAL" ] ; then
628   check4progs kpartx parted qemu-img || bailout 1
629 fi
630 # }}}
631
632 # source specified configuration file {{{
633 if [ -n "$CONFIGFILE" ] ; then
634   einfo "Reading specified config file $CONFIGFILE."
635   # shellcheck disable=SC1091 source=config
636   if ! . "$CONFIGFILE" ; then
637     eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
638   fi
639 fi
640 # }}}
641
642 # backwards compatibility checks {{{
643 if [ -n "$GROOT" ] ; then
644    eerror "Error: you seem to have \$GROOT configured."
645    eerror "This variable is no longer supported, please visit the"
646    eerror "grml-debootstrap documentation for details."
647    eend 1
648    bailout 1
649 fi
650
651 if echo "$GRUB" | grep -q '^hd' ; then
652    eerror "Error: this syntax for the grub configuration variable is no longer supported."
653    eerror "Please do not use hd... any longer but /dev/sdX instead."
654    eend 1
655    bailout 1
656 fi
657 # }}}
658
659 # welcome screen {{{
660 welcome_dialog()
661 {
662    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
663 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
664 }
665 # }}}
666
667 # ask for target {{{
668 prompt_for_target()
669 {
670   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
671                sed 's/*//' | \
672                grep -v 'Extended$' | \
673                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
674
675   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
676      dialog --title "$PN" --trim \
677      --msgbox "Sorry, no partitions found. Please configure your
678      harddisks (see /proc/partitions) using a tool like fdisk,
679      cfdisk, gpart, gparted,..." 0 0
680      bailout 1
681   fi
682
683   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
684                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
685                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
686                      echo "$i" "$fs"
687                      unset fs
688                    done)
689
690   # shellcheck disable=SC2086
691   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
692          --menu "Please select the target partition:" 0 0 0 \
693          $PARTITION_LIST)
694   [ $? -eq 0 ] || bailout 1
695 }
696 # }}}
697
698 # ask for bootmanager {{{
699 prompt_for_bootmanager()
700 {
701   ADDITIONAL_PARAMS=""
702
703   if echo "$TARGET" | grep -q "/dev/md" ; then
704      MBRPART="all disks of Software RAID $TARGET"
705   else
706      # figure out whole disk device
707      found=
708      for device in /dev/disk/by-id/*
709      do
710         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
711         found=1
712         break
713      done
714      # shellcheck disable=SC2001
715      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
716      if [ -e "$MBRDISK" ]; then
717         MBRDISK=$(readlink -f "$MBRDISK")
718      else
719         # fall back to old behaviour
720         # shellcheck disable=SC2001
721         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
722      fi
723
724      MBRPART="MBR of $MBRDISK"
725   fi
726
727   for device in cciss/c0d0 sda hda; do
728     if [ "/dev/$device" != "${MBRDISK}" ]; then
729       grep -q $device /proc/partitions && \
730       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
731     fi
732   done
733   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
734
735   OIFS="$IFS"; IFS=:
736
737   # shellcheck disable=SC2086
738   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
739           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
740             mbr       "install bootmanager into $MBRPART" \
741             nowhere   "do not install bootmanager at all" \
742           ${ADDITIONAL_PARAMS})
743   [ $? -eq 0 ] || bailout 3
744   IFS="$OIFS"
745
746   case "$GETMBR" in
747     mbr)
748       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
749       if echo "$TARGET" | grep -q "/dev/md" ; then
750         GRUB="$TARGET"
751       else
752         GRUB="$MBRDISK"
753       fi
754       ;;
755     hda)
756       GRUB="/dev/hda"
757       ;;
758     sda)
759       GRUB="/dev/sda"
760       ;;
761     nowhere)
762       GRUB=''
763       ;;
764   esac
765 }
766 # }}}
767
768 # ask for Debian release {{{
769 prompt_for_release()
770 {
771   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='buster'
772   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
773             "Please enter the Debian release you would like to use for installation:" \
774             0 50 8 \
775             lenny    Debian/5.0 \
776             squeeze  Debian/6.0 \
777             wheezy   Debian/7.0 \
778             jessie   Debian/8.0 \
779             stretch  Debian/9.0 \
780             buster   Debian/10.0 \
781             bullseye Debian/11.0 \
782             sid      Debian/unstable)"
783   [ $? -eq 0 ] || bailout
784 }
785 # }}}
786
787 # ask for hostname {{{
788 prompt_for_hostname()
789 {
790   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
791             "Please enter the hostname you would like to use for installation:" \
792             0 0 "$HOSTNAME")"
793   [ $? -eq 0 ] || bailout
794 }
795 # }}}
796
797 # ask for password {{{
798 prompt_for_password()
799 {
800   if [ "$_opt_nopassword" ] ; then
801     einfo "Skip asking for root password as requested."
802     return 0
803   fi
804
805   ROOTPW1='PW1'
806   ROOTPW2='PW2'
807   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
808     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
809     "Please enter the password for the root account:" 10 60)
810     [ $? -eq 0 ] || bailout
811
812     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
813     "Please enter the password for the root account again for \
814     confirmation:" 10 60)
815     [ $? -eq 0 ] || bailout
816
817     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
818       dialog --stdout --title "${PN}" --ok-label \
819         "Retry" --msgbox "Passwords do not match!" 10 60
820     fi
821   done
822   ROOTPASSWORD="$ROOTPW1"
823 }
824 # }}}
825
826 # ask for Debian mirror {{{
827 prompt_for_mirror()
828 {
829   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
830
831   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
832           --menu "Where do you want to install from?" 0 0 0 \
833             net   "install via network (downloading from mirror)" \
834             local "install from local directory/mirror"
835           )
836   [ $? -eq 0 ] || bailout
837
838   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
839      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
840      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
841                "Please enter Debian mirror you would like to use for installing packages." \
842                0 0 $MIRROR)"
843      [ $? -eq 0 ] || bailout
844   else # CHOOSE_MIRROR == local
845      [ -n "$ISO" ] || ISO='/mnt/mirror'
846      ISO="$(dialog --stdout --title "${PN}" --inputbox \
847                "Please enter directory name you would like to use for installing packages." \
848                0 0 $ISO)"
849      [ $? -eq 0 ] || bailout
850   fi
851 }
852 # }}}
853
854 # software raid setup {{{
855 config_swraid_setup()
856 {
857 TMPFILE=$(mktemp)
858
859 # Currently we support only raid1:
860 RAIDLEVEL='raid1'
861
862 MD_LIST=$(for i in $(seq 0 9) ; do
863             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
864             echo "/dev/md$i /dev/md$i"
865           done)
866
867 # shellcheck disable=SC2086
868 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
869 --menu "Which device do you want to use for ${RAIDLEVEL}?
870
871 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
872 $MD_LIST)
873 [ $? -eq 0 ] || bailout 20
874
875 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
876              sed 's/*//' | \
877              grep -v 'Extended$' | \
878              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
879 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
880 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
881                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
882                  done)
883
884 # shellcheck disable=SC2086
885 dialog --title "$PN" --separate-output \
886        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
887        $PARTITION_LIST 2>"$TMPFILE"
888 [ $? -eq 0 ] || bailout
889 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
890
891 NUM_PARTITIONS=0
892 while IFS= read -r i; do
893   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
894 done < "$TMPFILE"
895
896 # force metadata version 0.90 for lenny so old grub can boot from this array.
897 METADATA_VERSION=""
898 if [ "$RELEASE" = "lenny" ]; then
899    METADATA_VERSION="-e0"
900 fi
901
902 ERRORFILE=$(mktemp)
903 # shellcheck disable=SC2086
904 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
905       --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
906 RC=$?
907 if [ "$RC" = 0 ] ; then
908    dialog --title "$PN" --msgbox \
909    "Creating $TARGET was successful." 0 0
910    rm -f "$TMPFILE" "$ERRORFILE"
911 else
912    dialog --title "$PN" --msgbox \
913    "There was an error setting up $TARGET:
914
915 $(cat "$ERRORFILE")
916
917 Exiting." 0 0
918    rm -f "$TMPFILE" "$ERRORFILE"
919    bailout 1
920 fi
921
922 }
923
924 prompt_for_swraid()
925 {
926 if dialog --stdout --title "$PN" \
927           --defaultno --yesno "Do you want to configure Software RAID?
928
929 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
930   config_swraid_setup
931 fi
932 }
933 # }}}
934
935 # user should recheck his configuration {{{
936 # support full automatic installation:
937 checkforrun() {
938    dialog --timeout 10 --title "$PN" \
939           --yesno "Do you want to stop at this stage?
940
941 Notice: you are running ${PN} in non-interactive mode.
942 ${PN} will install Debian ${RELEASE} on ${TARGET}.
943 Last chance to quit. Timeout of 10 seconds running....
944
945 Do you want to stop now?" 0 0 2>/dev/null
946 }
947 # }}}
948
949 # format efi partition {{{
950 format_efi_partition() {
951   if [ -z "$EFI" ] ; then
952     return 0
953   fi
954
955   if ! [ -b "$EFI" ] ; then
956     eerror "Specified efi argument [$EFI] not a valid block device."
957     bailout 1
958   fi
959
960   if fsck.vfat -bn "$EFI" >/dev/null; then
961     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying." ; eend 0
962   else
963     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
964     mkfs.fat -F32 -n "EFI System Partition" "$EFI"
965     RC=$?
966     if [ $RC -eq 0 ] ; then
967       eend 0
968     else
969       eerror "Error while creating filesystem on ${EFI}."
970       eend 1
971       bailout 1
972     fi
973   fi
974 }
975 # }}}
976
977 # check for EFI support or try to enable it {{{
978 efi_support() {
979   if lsmod | grep -q efivars ; then
980     einfo "EFI support detected." ; eend 0
981     return 0
982   fi
983
984   if modprobe efivars &>/dev/null ; then
985     einfo "EFI support enabled now." ; eend 0
986     return 0
987   fi
988
989   return 1
990 }
991 # }}}
992
993 # make sure the user is aware of the used configuration {{{
994 checkconfiguration()
995 {
996
997 if efi_support ; then
998   if [ -z "$_opt_efi" ] ; then
999     ewarn "EFI support detected but no --efi option given, please consider enabling it." ; eend 0
1000   fi
1001 else
1002   if [ -n "$_opt_efi" ] ; then
1003      eerror "EFI option used but no EFI support detected." ; eend 0
1004      bailout 1
1005   fi
1006 fi
1007
1008 if [ -n "$AUTOINSTALL" ] ; then
1009    if checkforrun ; then
1010       eerror "Exiting as requested" ; eend 0
1011       bailout 1
1012    fi
1013 elif [ -n "$INTERACTIVE" ] ; then
1014
1015    INFOTEXT="Please recheck configuration before execution:
1016    "
1017    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1018    Target:          $TARGET"
1019    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1020    Install grub:    $GRUB"
1021    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1022    Install efi:     $EFI"
1023    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1024    Using release:   $RELEASE"
1025    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1026    Using hostname:  $HOSTNAME"
1027    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1028    Using mirror:    $MIRROR"
1029    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1030    Using ISO:       $ISO"
1031    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1032    Using arch:      $ARCH"
1033    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1034    Config files:    $CONFFILES"
1035
1036    INFOTEXT="$INFOTEXT
1037
1038 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1039
1040    dialog --title "$PN" --no-collapse \
1041           --yesno "$INFOTEXT" 0 0
1042    [ $? -eq 0 ] || bailout 0
1043
1044 else # if not running automatic installation display configuration and prompt for execution:
1045    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1046    echo
1047    echo "   Target:          $TARGET"
1048
1049    # do not display if MNTPOINT is the default one
1050    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1051
1052    if [ -n "$VIRTUAL" ] ; then
1053       echo "   Install grub:    yes"
1054    else
1055      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1056      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1057    fi
1058
1059    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1060    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1061    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1062    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1063    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1064    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1065    if [ -n "$VIRTUAL" ] ; then
1066       echo "   Deploying as Virtual Machine."
1067       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1068          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1069       fi
1070    fi
1071
1072    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1073       echo
1074       echo "   You do not have a TTY allocated, your password will be shown in"
1075       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1076    fi
1077
1078    echo
1079    echo "   Important! Continuing will delete all data from ${TARGET}!"
1080
1081    if [ -n "$FORCE" ] ; then
1082      einfo "Skip user acknowledgement as requested via --force option."
1083    else
1084      echo
1085      einfon "Is this ok for you? [y/N] "
1086      read -r a
1087      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1088         eerror "Exiting as requested." ; eend 1
1089         bailout 1
1090      fi
1091    fi
1092 fi
1093 }
1094 # }}}
1095
1096 # interactive mode {{{
1097 interactive_mode()
1098 {
1099   check4progs dialog || bailout 1
1100
1101   welcome_dialog
1102
1103   prompt_for_release
1104
1105   prompt_for_swraid
1106
1107   prompt_for_target
1108
1109   prompt_for_bootmanager
1110
1111   prompt_for_hostname
1112
1113   prompt_for_password
1114
1115   prompt_for_mirror
1116 }
1117
1118 # run interactive mode if we didn't get the according configuration yet
1119 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1120    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1121    INTERACTIVE=1
1122    interactive_mode
1123 fi
1124 # }}}
1125
1126 # architecture setup {{{
1127 if [ -n "$ARCH" ] ; then
1128    ARCHCMD="--arch $ARCH"
1129    ARCHINFO=" (${ARCH})"
1130 else
1131    ARCH="$(dpkg --print-architecture)"
1132    ARCHCMD="--arch $ARCH"
1133    ARCHINFO=" (${ARCH})"
1134 fi
1135 # }}}
1136
1137 # It is not possible to build amd64 on i686. {{{
1138 CURRENT_ARCH="$(uname -m)"
1139 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1140    if [ "$ARCH" = "amd64" ] ; then
1141       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
1142       bailout 1
1143    fi
1144 fi
1145 # }}}
1146
1147 # Support for generic release codenames is unavailable. {{{
1148 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1149    eerror "Generic release codenames (stable, testing) are unsupported. \
1150 Please use specific codenames such as stretch or buster." ; eend 1
1151    bailout 1
1152 fi
1153 # }}}
1154
1155 checkconfiguration
1156
1157 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1158 if [ -n "$TARGET" ] ; then
1159    SHORT_TARGET="${TARGET##*/}"
1160 else
1161    eerror "Please adjust $CONFFILES/config or..."
1162    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
1163    bailout 1
1164 fi
1165 # }}}
1166
1167 # stages setup {{{
1168 if [ -z "$STAGES" ] ; then
1169    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1170    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1171 fi
1172
1173 if [ -r "$STAGES"/grml-debootstrap ] ; then
1174    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1175       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1176       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
1177    fi
1178 fi
1179 # }}}
1180
1181 # partition handling {{{
1182 PARTITION=''
1183 DIRECTORY=''
1184
1185 set_target_directory(){
1186     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1187     DIRECTORY=1
1188     MNTPOINT="$TARGET"
1189     MKFS=''
1190     TUNE2FS=''
1191     FSCK=''
1192     # make sure we normalise the path to an absolute directory name so something like:
1193     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1194     # works
1195     TARGET="$(readlink -f "$TARGET")"
1196 }
1197
1198 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1199     PARTITION=1
1200 else
1201     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1202     if [[ $TARGET == "/dev/"* ]]; then
1203       eerror "Error: Will not create target directory $TARGET in /dev."
1204       eerror "  Please check the partition(s) of the blockdevice."; eend 1
1205       bailout 1
1206     fi
1207     set_target_directory
1208 fi
1209 # }}}
1210
1211 # make sure we have the right syntax when using an iso image {{{
1212 if [ -n "$ISO" ] ; then
1213    case $ISO in
1214       file*) # do nothing
1215       ;;
1216       *)
1217       ISO=file:$ISO
1218       ;;
1219    esac
1220 fi
1221 ISODIR=${ISO##file:}
1222 ISODIR=${ISODIR%%/}
1223 # }}}
1224
1225 # Debian ISOs do not contain signed Release files {{{
1226 if [ -n "$ISO" ] ; then
1227     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1228 fi
1229 # }}}
1230
1231 # create filesystem {{{
1232 mkfs() {
1233   if [ -n "$DIRECTORY" ] ; then
1234      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1235      return 0
1236   fi
1237
1238   if grep -q "$TARGET" /proc/mounts ; then
1239     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
1240     bailout 1
1241   fi
1242
1243   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1244   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1245   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1246     case "$MKFS" in
1247       mkfs.ext*)
1248         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1249         MKFS_OPTS="$MKFS_OPTS -F"
1250         eend 0
1251
1252         ;;
1253     esac
1254   fi
1255
1256   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1257   # by default, which requires a recent version of tune2fs on the target system then,
1258   # so disable this feature for older Debian releases where it's known to be unsupported
1259   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1260     case "$RELEASE" in
1261       lenny|squeeze|wheezy|jessie)
1262         # assume a more recent version if we can't identify the version via dpkg-query
1263         local e2fsprogs_version
1264         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1265         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1266           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1267           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1268           eend 0
1269         fi
1270         ;;
1271     esac
1272   fi
1273
1274   if [ -n "$MKFS" ] ; then
1275     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1276     # shellcheck disable=SC2086
1277     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1278
1279     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1280       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1281         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1282         eend 1
1283         bailout 1
1284       else
1285         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1286         tune2fs "$TARGET" -U "$DISK_IDENTIFIER"
1287         eend $?
1288       fi
1289     fi
1290
1291     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1292     # will fail to detect the uuid in the chroot
1293     if [ -n "$VIRTUAL" ] ; then
1294       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1295     elif echo "$TARGET" | grep -q "/dev/md" ; then
1296       blockdev --rereadpt "${TARGET}"
1297     else
1298       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1299       local main_device="${TARGET%%[0-9]*}"
1300       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1301       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1302         blockdev --rereadpt "$main_device"
1303       else
1304         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1305       fi
1306     fi
1307     # give the system 2 seconds, otherwise we might run into
1308     # race conditions :-/
1309     sleep 2
1310
1311     eend $RC
1312   fi
1313 }
1314 # }}}
1315
1316 # retrieve ID_FS_UUID {{{
1317 identify_target_uuid() {
1318   local device="$1"
1319
1320   if ! [ -b "$device" ] ; then
1321     return 1
1322   fi
1323
1324   eval "$(blkid -o udev "$1" 2>/dev/null)"
1325
1326   if [ -n "$ID_FS_UUID" ] ; then
1327     echo "$ID_FS_UUID"
1328   else
1329     return 1
1330   fi
1331 }
1332 # }}}
1333
1334 # identify TARGET_UUID {{{
1335 mountpoint_to_blockdevice() {
1336   TARGET_UUID=''
1337
1338   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1339   if [ -n "$TARGET_UUID" ] ; then
1340     einfo "Identified UUID $TARGET_UUID for $TARGET"
1341     return 0
1342   fi
1343
1344   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1345   for file in /sys/block/*/*/dev ; do
1346     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1347       local dev
1348       dev="${file%/dev}"
1349       dev="/dev/${dev##*/}"
1350       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1351
1352       if [ -n "$TARGET_UUID" ] ; then
1353         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1354         return 0
1355       fi
1356     fi
1357   done
1358 }
1359 # }}}
1360
1361 # modify filesystem settings {{{
1362 tunefs() {
1363   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1364      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1365      $TUNE2FS "$TARGET"
1366      eend $?
1367   fi
1368 }
1369 # }}}
1370
1371 # mount the new partition or if it's a directory do nothing at all {{{
1372 mount_target() {
1373   if [ -n "$DIRECTORY" ] ; then
1374      einfo "Running grml-debootstrap on a directory, nothing to mount."
1375   else
1376      if grep -q "$TARGET" /proc/mounts ; then
1377         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
1378      else
1379        if ! [ -d "${MNTPOINT}" ] ; then
1380           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1381        fi
1382        einfo "Mounting $TARGET to $MNTPOINT"
1383        mkdir -p "$MNTPOINT"
1384        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1385        eend $?
1386      fi
1387   fi
1388   if [ -n "$ISODIR" ] ; then
1389      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1390      mkdir -p "$MNTPOINT/$ISODIR"
1391      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1392      eend $?
1393   fi
1394 }
1395 # }}}
1396
1397 # prepare VM image for usage with debootstrap {{{
1398 prepare_vm() {
1399   if [ -z "$VIRTUAL" ] ; then
1400      return 0 # be quiet by intention
1401   fi
1402
1403   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1404      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1405      eend 1
1406      bailout 1
1407   fi
1408   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1409      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1410      eend 1
1411      bailout 1
1412   fi
1413
1414   # make sure loop module is present and a usable loop device exists
1415   modprobe -q loop
1416   if ! losetup -f >/dev/null 2>&1; then
1417     eerror "Error finding usable loop device" ; eend 1
1418     bailout 1
1419   fi
1420
1421   # if dm-mod isn't available then kpartx will fail with
1422   # "Is device-mapper driver missing from kernel? [...]"
1423   modprobe -q dm-mod
1424   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1425     eerror "Device-mapper support missing in kernel." ; eend 1
1426     bailout 1
1427   fi
1428
1429   ORIG_TARGET="$TARGET" # store for later reuse
1430
1431   if [ -n "$VMFILE" ]; then
1432     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1433   fi
1434   parted -s "${TARGET}" 'mklabel msdos'
1435   if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1436     einfo "Adjusting disk signature to a fixed (non-random) value"
1437     MBRTMPFILE=$(mktemp)
1438     dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1439     echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1440     dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1441     eend $?
1442   fi
1443   parted -s "${TARGET}" 'mkpart primary ext4 2M -1'
1444   parted -s "${TARGET}" 'set 1 boot on'
1445
1446   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3'
1447   if [ -z "${DEVINFO}" ] ; then
1448     eerror "Error setting up loopback device." ; eend 1
1449     bailout 1
1450   fi
1451
1452   # hopefully this always works as expected
1453   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1454   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1455   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1456   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
1457
1458   if [ -z "$TARGET" ] ; then
1459      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1460      bailout 1
1461   fi
1462 }
1463 # }}}
1464
1465 # make VM image bootable {{{
1466 grub_install() {
1467   if [ -z "${VIRTUAL}" ] ; then
1468      return 0
1469   fi
1470   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1471     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1472     return 0
1473   fi
1474
1475   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1476     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1477     bailout 1
1478   fi
1479
1480   mount -t proc none "${MNTPOINT}"/proc
1481   mount -t sysfs none "${MNTPOINT}"/sys
1482   mount -t devtmpfs udev "${MNTPOINT}"/dev
1483   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1484
1485 # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1486 # chroot-script skips installation for unset ${GRUB}
1487 if [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1488   einfo "Installing Grub as bootloader."
1489
1490   if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1491     echo "Notice: grub-pc package not present yet, installing it therefore."
1492     # shellcheck disable=SC2086
1493     DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y install $DPKG_OPTIONS grub-pc
1494   fi
1495
1496   mkdir -p "${MNTPOINT}/boot/grub"
1497   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1498      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1499      bailout 1
1500   fi
1501
1502   case "$RELEASE" in
1503     lenny|squeeze|wheezy)
1504       cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
1505       ;;
1506     *)
1507       cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1508       ;;
1509   esac
1510   dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1511   chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1512   dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1513   rm -f "${MNTPOINT}/tmp/core.img"
1514 fi
1515
1516   # workaround for Debian bug #918590 with lvm + udev:
1517   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1518   if [ -d /run/udev ] ; then
1519     einfo "Setting up bind-mount /run/udev"
1520     mkdir -p "${MNTPOINT}"/run/udev
1521     mount --bind /run/udev "${MNTPOINT}"/run/udev
1522     eend $?
1523   fi
1524
1525   einfo "Updating grub configuration file."
1526   chroot "${MNTPOINT}" update-grub
1527
1528   case "$RELEASE" in
1529     jessie)
1530       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1531       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1532       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1533       ;;
1534   esac
1535
1536   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1537     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1538     ewarn "Please note that your system might NOT be able to properly boot."
1539   else
1540     einfo "Adjusting grub.cfg for successful boot sequence."
1541     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1542   fi
1543
1544   # workaround for Debian bug #918590 with lvm + udev:
1545   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1546   if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1547     einfo "Unmounting bind-mount /run/udev"
1548     umount "${MNTPOINT}"/run/udev
1549     eend $?
1550   fi
1551
1552   umount "${MNTPOINT}"/proc
1553   umount "${MNTPOINT}"/sys
1554   umount "${MNTPOINT}"/dev/pts
1555   try_umount 3 "${MNTPOINT}"/dev
1556
1557 }
1558 # }}}
1559
1560 # unmount VM image {{{
1561 umount_target() {
1562   if [ -z "${VIRTUAL}" ] ; then
1563      return 0
1564   fi
1565
1566   umount "${MNTPOINT}"
1567   kpartx -d "${ORIG_TARGET}" >/dev/null
1568   # Workaround for a bug in kpartx which doesn't clean up properly,
1569   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1570   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1571     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1572   fi
1573 }
1574 # }}}
1575
1576 # install main chroot {{{
1577 debootstrap_system() {
1578   if [ "$_opt_nodebootstrap" ]; then
1579      einfo "Skipping debootstrap as requested."
1580      return
1581   fi
1582
1583   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1584     :
1585   else
1586     eerror "Error: $MNTPOINT not mounted, can not continue."
1587     eend 1 ; exit 1
1588   fi
1589
1590   if [ -n "$ISO" ] ; then
1591     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1592     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1593     # shellcheck disable=SC2086
1594     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1595     RC=$?
1596   else
1597     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1598     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1599     # shellcheck disable=SC2086
1600     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1601     RC=$?
1602   fi
1603
1604   if [ $RC -ne 0 ] ; then
1605     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1606       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1607       einfo "Presenting last ten lines of debootstrap.log:"
1608       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1609       einfo "End of debootstrap.log"
1610     fi
1611   fi
1612
1613   eend $RC
1614 }
1615 # }}}
1616
1617 # prepare chroot via chroot-script {{{
1618 preparechroot() {
1619   einfo "Preparing chroot system"
1620
1621   # provide variables to chroot system
1622   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1623   touch "$CHROOT_VARIABLES"
1624   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1625   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1626   # Resorting to sed(1) for escaping since "VAR='${VAR//\'/\'\\\'\'}'" does not work with all versions of Bash,
1627   #   e.g. not with 4.2.37(1)-release (a.k.a 4.2+dfsg-0.1+deb7u3) of Debian wheezy
1628   [ -n "$ARCH" ]                && echo "ARCH='$(sed "s,','\\\\'',g" <<<"${ARCH}")'"                               >> "$CHROOT_VARIABLES"
1629   [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS='$(sed "s,','\\\\'',g" <<<"${BACKPORTREPOS}")'"             >> "$CHROOT_VARIABLES"
1630   [ -n "$BOOT_APPEND" ]         && echo "BOOT_APPEND='$(sed "s,','\\\\'',g" <<<"${BOOT_APPEND}")'"                 >> "$CHROOT_VARIABLES"
1631   [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${CHROOT_SCRIPTS}")'"           >> "$CHROOT_VARIABLES"
1632   [ -n "$COMPONENTS" ]          && echo "COMPONENTS='$(sed "s,','\\\\'',g" <<<"${COMPONENTS}")'"                   >> "$CHROOT_VARIABLES"
1633   [ -n "$CONFFILES" ]           && echo "CONFFILES='$(sed "s,','\\\\'',g" <<<"${CONFFILES}")'"                     >> "$CHROOT_VARIABLES"
1634   [ -n "$DEBCONF" ]             && echo "DEBCONF='$(sed "s,','\\\\'',g" <<<"${DEBCONF}")'"                         >> "$CHROOT_VARIABLES"
1635   [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND='$(sed "s,','\\\\'',g" <<<"${DEBIAN_FRONTEND}")'"         >> "$CHROOT_VARIABLES"
1636   [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP='$(sed "s,','\\\\'',g" <<<"${DEBOOTSTRAP}")'"                 >> "$CHROOT_VARIABLES"
1637   [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LOCALES}")'"         >> "$CHROOT_VARIABLES"
1638   [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LANGUAGE}")'"       >> "$CHROOT_VARIABLES"
1639   [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES='$(sed "s,','\\\\'',g" <<<"${EXTRAPACKAGES}")'"             >> "$CHROOT_VARIABLES"
1640   [ -n "$EFI" ]                 && echo "EFI='$(sed "s,','\\\\'',g" <<<"${EFI}")'"                                 >> "$CHROOT_VARIABLES"
1641   [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR='$(sed "s,','\\\\'',g" <<<"${FALLBACK_MIRROR}")'"         >> "$CHROOT_VARIABLES"
1642   [ -n "$FORCE" ]               && echo "FORCE='$(sed "s,','\\\\'',g" <<<"${FORCE}")'"                             >> "$CHROOT_VARIABLES"
1643   [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS='$(sed "s,','\\\\'',g" <<<"${GRMLREPOS}")'"                     >> "$CHROOT_VARIABLES"
1644   [ -n "$GRUB" ]                && echo "GRUB='$(sed "s,','\\\\'',g" <<<"${GRUB}")'"                               >> "$CHROOT_VARIABLES"
1645   [ -n "$HOSTNAME" ]            && echo "HOSTNAME='$(sed "s,','\\\\'',g" <<<"${HOSTNAME}")'"                       >> "$CHROOT_VARIABLES"
1646   [ -n "$INITRD" ]              && echo "INITRD='$(sed "s,','\\\\'',g" <<<"${INITRD}")'"                           >> "$CHROOT_VARIABLES"
1647   [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES='$(sed "s,','\\\\'',g" <<<"${INSTALL_NOTES}")'"             >> "$CHROOT_VARIABLES"
1648   [ -n "$ISODIR" ]              && echo "ISODIR='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                              >> "$CHROOT_VARIABLES"
1649   [ -n "$ISO" ]                 && echo "ISO='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                                 >> "$CHROOT_VARIABLES"
1650   [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST='$(sed "s,','\\\\'',g" <<<"${KEEP_SRC_LIST}")'"             >> "$CHROOT_VARIABLES"
1651   [ -n "$LOCALES" ]             && echo "LOCALES='$(sed "s,','\\\\'',g" <<<"${LOCALES}")'"                         >> "$CHROOT_VARIABLES"
1652   [ -n "$MIRROR" ]              && echo "MIRROR='$(sed "s,','\\\\'',g" <<<"${MIRROR}")'"                           >> "$CHROOT_VARIABLES"
1653   [ -n "$MKFS" ]                && echo "MKFS='$(sed "s,','\\\\'',g" <<<"${MKFS}")'"                               >> "$CHROOT_VARIABLES"
1654   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
1655   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
1656   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
1657   [ -n "$POST_SCRIPTS" ]        && echo "POST_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${POST_SCRIPTS}")'"               >> "$CHROOT_VARIABLES"
1658   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
1659   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
1660   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
1661   [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE='$(sed "s,','\\\\'',g" <<<"${RM_APTCACHE}")'"                 >> "$CHROOT_VARIABLES"
1662   [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD='$(sed "s,','\\\\'',g" <<<"${ROOTPASSWORD}")'"               >> "$CHROOT_VARIABLES"
1663   [ -n "$SCRIPTS" ]             && echo "SCRIPTS='$(sed "s,','\\\\'',g" <<<"${SCRIPTS}")'"                         >> "$CHROOT_VARIABLES"
1664   [ -n "$SECURE" ]              && echo "SECURE='$(sed "s,','\\\\'',g" <<<"${SECURE}")'"                           >> "$CHROOT_VARIABLES"
1665   [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS='$(sed "s,','\\\\'',g" <<<"${SELECTED_PARTITIONS}")'" >> "$CHROOT_VARIABLES"
1666   [ -n "$TARGET" ]              && echo "TARGET='$(sed "s,','\\\\'',g" <<<"${TARGET}")'"                           >> "$CHROOT_VARIABLES"
1667   [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM='$(sed "s,','\\\\'',g" <<<"${UPGRADE_SYSTEM}")'"           >> "$CHROOT_VARIABLES"
1668   [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID='$(sed "s,','\\\\'',g" <<<"${TARGET_UUID}")'"                 >> "$CHROOT_VARIABLES"
1669   [ -n "$TIMEZONE" ]            && echo "TIMEZONE='$(sed "s,','\\\\'',g" <<<"${TIMEZONE}")'"                       >> "$CHROOT_VARIABLES"
1670   [ -n "$TUNE2FS" ]             && echo "TUNE2FS='$(sed "s,','\\\\'',g" <<<"${TUNE2FS}")'"                         >> "$CHROOT_VARIABLES"
1671   [ -n "$VMSIZE" ]              && echo "VMSIZE='$(sed "s,','\\\\'',g" <<<"${VMSIZE}")'"                           >> "$CHROOT_VARIABLES"
1672
1673   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1674   chmod 755 "${MNTPOINT}"/bin/chroot-script
1675   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1676
1677   # make sure we have our files for later use via chroot-script
1678   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1679   # make sure we adjust the configuration variables accordingly:
1680   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1681   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1682   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1683
1684   # install notes:
1685   if [ -n "$INSTALL_NOTES" ] ; then
1686      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1687   fi
1688
1689   # package selection:
1690   if [ "$PACKAGES" = 'yes' ] ; then
1691     cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
1692       "${MNTPOINT}"/etc/debootstrap/packages
1693   fi
1694
1695   # debconf preseeding:
1696   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1697   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1698     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1699
1700   # copy scripts that should be executed inside the chroot:
1701   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1702   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1703     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1704     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1705   }
1706
1707   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1708   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1709
1710   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1711
1712   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1713   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1714
1715   # setup default locales
1716   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1717
1718   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
1719   ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
1720
1721   # copy any existing files to chroot
1722   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1723   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1724   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1725   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1726   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1727   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1728   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1729
1730   # network setup
1731   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1732
1733 # Include files from /etc/network/interfaces.d when using
1734 # ifupdown v0.7.44 or newer:
1735 #source-directory /etc/network/interfaces.d
1736
1737 auto lo
1738 iface lo inet loopback
1739
1740 allow-hotplug eth0
1741 iface eth0 inet dhcp
1742 "
1743
1744   # add dhcp setting for Predictable Network Interface Names
1745   if [ -x /bin/udevadm ]; then
1746     tmpfile=$(mktemp)
1747     for interface in /sys/class/net/*; do
1748       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1749       # skip virtual devices, like bridges, vboxnet,...
1750       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1751         continue
1752       fi
1753
1754       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1755       # use and stop on first match to have same behavior as udev's link_config_apply()
1756       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1757         if grep -q "${property}" "${tmpfile}" ; then
1758           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1759           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1760 allow-hotplug ${interface}
1761 iface ${interface} inet dhcp
1762 "
1763           break
1764         fi
1765       done
1766     done
1767     rm -f "${tmpfile}"
1768   fi
1769
1770   if [ -n "$NOINTERFACES" ] ; then
1771     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option" ; eend 0
1772   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1773     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1774     mkdir -p "${MNTPOINT}/etc/network"
1775     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1776     eend $?
1777   elif [ -n "$VIRTUAL" ] ; then
1778     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1779     mkdir -p "${MNTPOINT}/etc/network"
1780     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1781     eend $?
1782   elif [ -r /etc/network/interfaces ] ; then
1783     einfo "Copying /etc/network/interfaces from host to target system"
1784     mkdir -p "${MNTPOINT}/etc/network"
1785     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1786     eend $?
1787   else
1788     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1789     mkdir -p "${MNTPOINT}/etc/network"
1790     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1791     eend $?
1792   fi
1793
1794   # install config file providing some example entries
1795   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1796     mkdir -p "${MNTPOINT}/etc/network"
1797     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1798   fi
1799
1800   if [ -n "${SSHCOPYID}" ] ; then
1801     if ssh-add -L >/dev/null 2>&1 ; then
1802       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1803       mkdir -p "${MNTPOINT}"/root/.ssh
1804       chmod 0700 "${MNTPOINT}"/root/.ssh
1805       if ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1806         eend 0
1807       else
1808         eerror "Error: executing 'ssh-add -L' failed."
1809         eend 1
1810         bailout 1
1811       fi
1812     else
1813       eerror "Could not open a connection to your authentication agent or the agent has no identites."
1814       eend 1
1815       bailout 1
1816     fi
1817   fi
1818
1819   if [ -d /run/udev ] ; then
1820     einfo "Setting up bind-mount /run/udev"
1821     mkdir -p "${MNTPOINT}"/run/udev
1822     mount --bind /run/udev "${MNTPOINT}"/run/udev
1823     eend $?
1824   fi
1825
1826   eend 0
1827 }
1828 # }}}
1829
1830 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1831 execute_pre_scripts() {
1832   # make sure hostname is set even before chroot-script get executed
1833   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1834
1835   # make sure we have $MNTPOINT available for our scripts
1836   export MNTPOINT
1837
1838   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1839     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
1840     for script in "${pre_scripts}"/* ; do
1841       if [ -x "$script" ] ; then
1842         einfo "Executing pre-script $script"
1843         "$script" ; eend $?
1844       fi
1845     done
1846   fi
1847 }
1848 # }}}
1849
1850 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
1851 execute_post_scripts() {
1852   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
1853   export MNTPOINT
1854   export TARGET_HOSTNAME=$HOSTNAME
1855
1856   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
1857     # legacy support for /etc/debootstrap/scripts/
1858     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
1859     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
1860   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
1861     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
1862   fi
1863
1864   if [ -n "$post_scripts" ] ; then
1865     for script in "${post_scripts}"/* ; do
1866       if [ -x "$script" ] ; then
1867         einfo "Executing post-script $script"
1868         "$script" ; eend $?
1869       fi
1870     done
1871   fi
1872 }
1873 # }}}
1874
1875 # unmount mountpoint {{{
1876 try_umount() {
1877   local tries=$1
1878   local mountpoint="$2"
1879
1880   for (( try=1; try<=tries; try++ )); do
1881     if [[ ${try} -eq ${tries} ]]; then
1882       # Last time, show errors this time
1883       umount "${mountpoint}" && return 0
1884     else
1885       # Not last time, hide errors until fatal
1886       if umount "${mountpoint}" 2>/dev/null ; then
1887         return 0
1888       else
1889         sleep 1
1890       fi
1891     fi
1892   done
1893   return 1  # Tried enough
1894 }
1895 # }}}
1896
1897 # execute chroot-script {{{
1898 chrootscript() {
1899   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
1900     mount_target
1901   fi
1902
1903   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
1904     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
1905     eend 1
1906   else
1907     einfo "Executing chroot-script now"
1908     mount -t devtmpfs udev "${MNTPOINT}"/dev
1909     mount -t devpts devpts "${MNTPOINT}"/dev/pts
1910     if [ "$DEBUG" = "true" ] ; then
1911       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
1912     else
1913       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
1914     fi
1915     try_umount 3 "$MNTPOINT"/dev/pts
1916     try_umount 3 "$MNTPOINT"/dev
1917     eend $RC
1918   fi
1919
1920   # finally get rid of chroot-script again, there's no good reason to
1921   # keep it on the installed system
1922   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
1923     einfo "Removing chroot-script again"
1924     rm -f "${MNTPOINT}/bin/chroot-script"
1925     eend $?
1926   else
1927     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
1928     eend 0
1929   fi
1930 }
1931 # }}}
1932
1933 # unmount $MNTPOINT {{{
1934 umount_chroot() {
1935
1936   # display installation notes:
1937   if [ -n "$INSTALL_NOTES" ] ; then
1938      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
1939   fi
1940
1941   if [ -n "$ISODIR" ] ; then
1942      if grep -q "$ISODIR" /proc/mounts ; then
1943         einfo "Unmount $MNTPOINT/$ISODIR"
1944         umount "$MNTPOINT/$ISODIR"
1945         eend $?
1946      fi
1947   fi
1948
1949   if grep -q "$MNTPOINT" /proc/mounts ; then
1950     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1951       einfo "Unmounting bind-mount /run/udev"
1952       umount "${MNTPOINT}"/run/udev
1953       eend $?
1954     fi
1955
1956      if [ -n "$PARTITION" ] ; then
1957         einfo "Unmount $MNTPOINT"
1958         umount "$MNTPOINT"
1959         eend $?
1960      fi
1961   fi
1962 }
1963 # }}}
1964
1965 # execute filesystem check {{{
1966 fscktool() {
1967  if [ -n "$VIRTUAL" ] ; then
1968    einfo "Skipping filesystem check because we deploy a virtual machine."
1969    return 0
1970  fi
1971
1972  if [ "$FSCK" = 'yes' ] ; then
1973    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
1974    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
1975    "$FSCKTOOL" "$TARGET"
1976    eend $?
1977  fi
1978 }
1979 # }}}
1980
1981 # get rid of grml-debootstrap config files {{{
1982 remove_configs() {
1983   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
1984     return 0
1985   fi
1986
1987   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
1988     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files." ; eend 0
1989     return 0
1990   fi
1991
1992   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
1993   rm -rf "${MNTPOINT}"/etc/debootstrap/
1994   eend $?
1995 }
1996 # }}}
1997
1998 # now execute all the functions {{{
1999 for i in format_efi_partition prepare_vm mkfs tunefs \
2000          mount_target mountpoint_to_blockdevice debootstrap_system \
2001          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2002          remove_configs umount_chroot grub_install umount_target fscktool ; do
2003     if stage "${i}" ; then
2004       if "$i" ; then
2005         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
2006       else
2007         bailout 2 "$i"
2008       fi
2009     fi
2010 done
2011
2012 cleanup
2013 # }}}
2014
2015 # end dialog of autoinstallation {{{
2016 if [ -n "$AUTOINSTALL" ] ; then
2017    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2018 Automatically rebooting in 10 seconds.
2019
2020 Choose Cancel to skip rebooting." 10 60 10 ; then
2021      noeject noprompt reboot
2022   fi
2023 else
2024    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
2025 fi
2026 # }}}
2027
2028 ## END OF FILE #################################################################
2029 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2